#!/bin/bash

name=bzwx-nce
version="1.0.4"
release="0"

# compile
make driver-pf_clean
make driver-vf_clean
make driver-pf
make driver-vf

# clear workspace dir
rm -rf deb_workspace
rm -rf ${name}*.deb

# crate workspace dir
mkdir -p deb_workspace/lib/modules/$(uname -r)/drivers/net/ethernet/bzwx/nce
mkdir -p deb_workspace/usr/share/doc/${name}
mkdir -p deb_workspace/usr/share/man/man7

if [ -d DEBIAN ]; then
	cp -rf DEBIAN deb_workspace/
	sed -i "s/Package: /Package: ${name}/g" deb_workspace/DEBIAN/control
	sed -i "s/Version: /Version: ${version}/g" deb_workspace/DEBIAN/control
	sed -i "s/Architecture: /Architecture: $(dpkg --print-architecture)/g" deb_workspace/DEBIAN/control
	sed -i "s/name=/name=${name}/g" deb_workspace/DEBIAN/prerm
	chmod -R 555 deb_workspace/DEBIAN/*
else
	echo "DEBIAN directory not exist"
fi

# ko install dir
if [ -f ne6x/ncepf.ko ] && [ -f ne6x_vf/ncevf.ko ]; then
	cp ne6x/ncepf.ko deb_workspace/lib/modules/$(uname -r)/drivers/net/ethernet/bzwx/nce/
	cp ne6x_vf/ncevf.ko deb_workspace/lib/modules/$(uname -r)/drivers/net/ethernet/bzwx/nce/
else
	echo "ncepf.ko or ncevf.ko not exist"
fi

# doc dir
cp -f COPYING deb_workspace/usr/share/doc/${name}/
cp -f pci.updates deb_workspace/usr/share/doc/${name}
cp -f README deb_workspace/usr/share/doc/${name}/
echo "/lib/modules/$(uname -r)/drivers/net/ethernet/bzwx/nce/ncepf.ko" > deb_workspace/usr/share/doc/${name}/file.list
echo "/lib/modules/$(uname -r)/drivers/net/ethernet/bzwx/nce/ncevf.ko" >> deb_workspace/usr/share/doc/${name}/file.list

# man dir
cp -f nce.7 deb_workspace/usr/share/man/man7/
gzip deb_workspace/usr/share/man/man7/nce.7 > /dev/null 2>&1

# create deb package
dpkg -b deb_workspace ${name}-${version}-${release}.$(dpkg --print-architecture).deb

# clear workspace again
rm -rf deb_workspace
