#include <fcntl.h>
#include <getopt.h>
#include <net/if.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include <arpa/inet.h>
#include <errno.h>
#include "ne6x_meterwrite.h"
#include "ne6x_whitelist.h"
#include "ne6x_tpl.h"

static void usage(char *appName)
{
	printf("\r\n"
	       "Usage: %s [-h] -i <interface> -f <package> \r\n"
	       " -h             Print this message and exit\r\n"
	       " -w		whitelist function\r\n"
	       " -a             add whitelist or write tpl\r\n"
	       " -r             rm whitelist or read tpl\r\n"
	       " -m		meterwrite function\r\n"
	       " -t		templ function  \r\n"
	       " -p [param] '\r\n"
	       " -i [device]    Interface to use, for example 'eth0'\r\n"
	       " -f [filename]  Specify the Settings filename, for example 'test.xml'\r\n"
	       " If none of l/a/n/i specified, then all parts will be updated.\r\n",
	       appName);
}

static int32_t configure_parse_ops(uint32_t argc, char *argv[])
{
	uint32_t c;
	char *appName = argv[0];

	if (argc < 2) {
		usage(appName);
		return -1;
	}

	while (EOF != (c = getopt(argc, argv, "tlarnhmwp:i:f:"))) {
		switch (c) {
		case 'm':
			return 1;
		case 'w':
			return 2;
		case 't':
			return 3;		
		case 'h':
			usage(appName);
			return 0;
		default:
			printf("Unsupported argument11!\n");
			return -1;
		}
	}
	return 0;
}

int32_t main(int argc, char *argv[])
{
	int ret = configure_parse_ops(argc,argv);
	if(ret == 1)
	{
		return send_meterwrite(argc,argv);
	}
	else if(ret == 2)
	{
		return send_whitelist(argc,argv);
	}
	else if(ret == 3)
	{
		return send_tpl(argc,argv);
	}
	return 0;
}




