////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//      Copyright 2021-2022 by BZW Ltd. All rights reserved.            //
//                                                                            //
//      Abstract:                                                             //
//      This file contains routiness for CRC-32                               //
//      Width        = 32                                                     //
//      Poly         = 0x04c11db7                                             //
//      XorIn        = 0xffffffff                                             //
//      ReflectIn    = True                                                   //
//      XorOut       = 0xffffffff                                             //
//      ReflectOut   = True                                                   //
//                                                                            //
//      Revision History:                                                     //
//      07-17-12: created                                                     //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


#ifndef _CRC32_H_
#define _CRC32_H_

#include <stdint.h>

#define DUMMY_CRC   0xFFFFFFFFU
#define CRC32_POLYNOMIAL            0x04C11DB7U
#define CRC32_REVERSED_POLYNOMIAL   0xEDB88320U
#define CRC32_INITIAL_REMAINDER     0xFFFFFFFFU
#define CRC32_FINALIZE_REMAINDER    0xFFFFFFFFU
#define CRC32_TABLE_SIZE            256U

void  Crc32Init(void);
uint32_t   Crc32(const void *pMessage, uint32_t bytes);
uint32_t   Crc32_Part(uint32_t crc32, const void *pMessage, uint32_t bytes);
#endif // _CRC32_H_


